'*** Citrix check ***
'
'Created by Tom De Blende ~ 2002
'
'#################################################################################################################################

Option Explicit                 'All variables should be explicitly declared

'#################################################################################################################################

'DECLARING VARIABLES

'Declaring Objects
'
Dim objFSO                  'Object file system
Dim objWshNetwork           'Object network
Dim objWshShell             'Object shell
Dim objWshEnv               'Object environment
Dim objFile

'Declaring string variables
'
Dim strStatus
Dim strNote
Dim strDateUnix0
Dim strDateNow
Dim strDate
Dim strFile
Dim strHost
Dim strService
Dim strPass
Dim strUser
Dim strServer
Dim strPipe

'Declaring integers
Dim intTimeDiff

'Declaring arrays
'


'#################################################################################################################################

Set objWshNetwork = Wscript.CreateObject("Wscript.Network")
Set objFSO = Wscript.CreateObject("Scripting.FileSystemObject")
Set objWshShell = Wscript.CreateObject("Wscript.Shell")
Set objWshEnv = objWshShell.Environment("PROCESS")

'#################################################################################################################################

'CHANGE THESE SETTINGS:

'Enter the hostname the Citrix host has in NetSaint (case sensitive!), you can use the predefined function, or enter this hard-coded
strHost = LCase(objWshNetwork.ComputerName)
'Enter the Service Description this service has in NetSaint (case sensitive!)
strService = "Citrix Logins"
'Enter the time difference in minutes between your time zone and UTC.
intTimeDiff = "7200"
'Enter the name of the temp file
strFile = "d:\temp\status.tmp"
'Enter the password of the user that will write to the pipe
strPass = "c1tr1x"
'Enter the username of the user that will write to the pipe
strUser = "citrix"
'Enter the name of the Nagios server
strServer = "netsaint"
'Enter the name of the Nagios external command file
strPipe = "/usr/local/nagios/var/rw/nagios.cmd"

'#################################################################################################################################


'NOTHING TO BE CHANGED FROM HERE EXCEPT SSH PARAMETERS OF PLINK

'Calculate time_t Unix Time
strDateUnix0 = "1/01/70 00:00:00"
strDateNow = Now
strDate = DateDiff ("s", strDateUnix0, strDateNow)
strDate = strDate - intTimeDiff

'Read logon status from registry
strStatus = objWshShell.RegRead ("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon\WinStationsDisabled")

'Assign error code and comments
If strStatus = "0" Then
    strNote = "Remote Citrix logins are currently ENABLED."
ElseIf strStatus = "1" Then
    strNote = "Remote Citrix logins are currently DISABLED."
End If

'Append info to a text file in the correct format.
Set objFile = objFSO.OpenTextFile(strFile, 2, True)
objFile.WriteLine "echo '[" & strDate & "] PROCESS_SERVICE_CHECK_RESULT;" & strHost & ";" & strService & ";" & strStatus & ";" & strNote & "' >> /usr/local/nagios/var/rw/nagios.cmd"
objFile.Close

objWshShell.Run "plink.exe -ssh -pw " & strPass & " -m " & strFile & " " & strUser & "@" & strServer, 0, True

Wscript.Quit